#!@@PERL@@

# snmp_gather
#						Author: Rich West
#						Rich.West@wesmo.com
#
# A simple Perl script which uses SNMP to gather specific system data from
# snmp-aware hosts and enter/update that data in the database.
################################################################################

$DEBUG = 1;

use SNMP;
use Net::Ping;

&usage() if ($#ARGV+1 < 1 || $#ARGV+1 > 2);

&main($ARGV[0],$ARGV[1]);

################################################################################
#
# Our Database Information
#
################################################################################
sub db_settings
{
   $dbhost = "@@DBHOST@@";
   $dbname = "@@DB@@";
   $dbuser = "@@DBUSER@@";
   $dbpass = "@@DBPASS@@";
}

################################################################################
#
# Connect to the Database
#
################################################################################
sub connectdb
{
   local($dbname) = @_;

   if (!($dbh = Mysql->Connect($dbhost, $dbname, $dbuser, $dbpass,)))
   {
      die "[connectdb] Database connect failed: $Mysql::db_errstr\n";
   }
}

################################################################################
#
# The standard usage statement.
#
################################################################################
sub usage
{
   print STDERR "usage: $0 IP_ADDRESS [community]\n";
   print STDERR "If not supplied, community will default to \"public\".\n\n";
   exit 1;
}

################################################################################
#
# Grab all of the available data from the host.  This will grow with time.
#
################################################################################
sub parse_host
{
   ($host,$community) = @_;

   $session = new SNMP::Session
      (
         DestHost => $host,
         Community => $community
      );
   @system_info =
      (
         "sysDescr.0",
         "sysName.0",
         "sysContact.0",
         "sysLocation.0",
      );

   $i=0;
   foreach $field (@system_info)
   {
      @value[$i] = $session->get($field);
      $i++
   }
   return (@value);
}

################################################################################
#
# Remove all of the white spaces.
#
################################################################################
sub massage_data
{
   local (@values) = @_;

   $values[0] = (split(/\s+/, $values[0]))[0];
   return (@values);
}

################################################################################
#
# Solely for debugging.  Displays the contents to the screen.
#
################################################################################
sub print_data
{
   local (@entries) = @_;

   foreach $entry (@entries)
   {
      print "$entry\n";
   }
}

################################################################################
#
# Update the database accordingly.
#
################################################################################
sub record_date
{
   local($host) = @_;
   local($id, $qs, $sth);

   $id = &get_id($host);
   $qs = "UPDATE changes SET date='blah' WHERE id='$id'";
   $sth = $dbh->Query($qs)
      or warn "[record_date] Query had some problem: $Mysql::db_errstr\n$qs\n";
}

################################################################################
#
# Update the database accordingly.
#
################################################################################
sub updatedb
{
   local(@elements) = @_;
   local($id,$qs,$sth);

   $id = &get_id($host);
   $qs = "UPDATE owner SET OwnerName='$elements[2]',Location='$elements[3]' WHERE id='$id'";
   $sth = $dbh->Query($qs)
      or warn "[updatedb] Query had some problem: $Mysql::db_errstr\n$qs\n";
   $qs = "UPDATE name SET Machine_Name='$elements[1]' WHERE id='$id'";
   $sth = $dbh->Query($qs)
      or warn "[updatedb] Query had some problem: $Mysql::db_errstr\n$qs\n";
}

################################################################################
#
# Get the database id for this entry.
#
################################################################################
sub get_id
{
   local($host) = @_;
   local($qs,$sth,@row);

   $qs="select name.id FROM name WHERE IP_Address='$host'";
   $sth = $dbh->Query($qs)
      or warn("[get_id] Query had some problem: $Mysql::db_errstr\n$qs\n");
   @row=$sth->FetchRow;
   return ($row[0]);
}

################################################################################
#
# The brains of the script.
#
################################################################################
sub main
{
   ($host,$community) = @_;
   local($pingable);

   $community = "public" if (!$community);

#   $pingable = Net::Ping->new();
#   if ($pingable->ping($host))
#   {
      @elements = &parse_host($host, $community);
      @elements = &massage_data(@elements);
      print_data(@elements) if($DEBUG);
#      &db_settings();
#      &connectdb("@@DB@@");
#      &updatedb(@elements);
#      &record_date($host);
#   }
#   $pingable->close();
}
